#!/bin/bash

for i in ./SST_PSO_2/*.TGZ ; do 
  temp=./tempPSO ;
  ascii=./SST_PSO_2_ascii ;

  echo creating directory "${temp}" ;
  if [ -e ${temp} ] ;
  then
    echo ... already exists ... deleting its content.
    rm -r ${temp} 
    mkdir ${temp} 
  else
    mkdir ${temp} 
  fi

  echo creating directory "${ascii}" ;
  if [ -e ${ascii} ] ;
  then
    echo ... already exists ... moving on.
  else
     mkdir ${ascii} 
  fi

  file=${i:12} ;
  pos=`expr index "$file" .` ;
  file=${file:0:$pos} ;
  

  echo working on $file ; 

  echo extracting $i to $temp ;
  tar -zxvf $i -C $temp ;

  echo transforming ${temp}/${file} ... ;
  ./gocexml2ascii/gocexml2ascii --if=${file}DBL --hdr=${file}HDR --dir=${temp}/
#  ./hpf_eef_transform.pl --verbose --output $temp ${temp}/${file}HDR ${temp}/${file}DBL

  echo packing to ${ascii}/${file}zip
  7z a -tzip ${ascii}/${file}zip ${temp}/*.ascii ${temp}/*.pdf

  mv ${i} ${i}.finish ;

  echo deleting ${temp}
  rm -r ${temp}
done