#include <string.h>
#include <math.h>
#include "helpers.h"

int strpos(char *haystack, char *needle)
{
  char *p = strstr(haystack, needle);
  if (p)
    return p - haystack;
  return STRPOS_NOTFOUND;
}


double greg2jul(double YY, double MM, double D, double h, double m, double s)
{
  double Y, M, H, A, B;
  
  if (MM > 2.0) {
    Y = YY; M = MM;
  } else {
    Y = YY - 1.0; M = MM + 12.0;
  }

  H = h / 24.0 + m / 1440.0 + s / 86400.0;

  A = floor(Y / 100.0);
  B = 2.0 - A + floor(A / 4.0);

  return floor(365.25 * (Y + 4716.0)) + floor(30.6001 * (M + 1.0)) + D + H + B - 1524.5;
}
