#include <string.h>

#include <libxml/xmlreader.h>

#include "tags.h"

int GetNodeTagfromName(const xmlChar *name, int level) {
  int tag = TAG_0_ERROR;

  switch (level) {
  case 0:
    if (strcmp(name, "Data_Block") == 0) tag = TAG_0_Data_Block;
    else tag = TAG_0_ERROR;
    break;

  case 1:
    if (strcmp(name, "EGG_NOM_2") == 0) tag = TAG_1_EGG_NOM_2;
    else if (strcmp(name, "SST_PSO_2") == 0) tag = TAG_1_SST_PSO_2;
    else tag = TAG_1_ERROR;
    break;

  case 2:
    if (strcmp(name, "List_of_GG_time_Records") == 0) tag = TAG_2_List_of_GG_time_Records;
    else if (strcmp(name, "SST_PCV_2") == 0) tag = TAG_2_SST_PCV_2;
    else if (strcmp(name, "SST_PKI_2") == 0) tag = TAG_2_SST_PKI_2;
    else if (strcmp(name, "SST_PRD_2") == 0) tag = TAG_2_SST_PRD_2;
    else if (strcmp(name, "SST_PRM_2") == 0) tag = TAG_2_SST_PRM_2;
    else if (strcmp(name, "SST_PRP_2") == 0) tag = TAG_2_SST_PRP_2;
    else tag = TAG_2_ERROR;
    break;

  case 3:
    if (strcmp(name, "GG_time_Record") == 0)                  tag = TAG_3_GG_time_Record;
    else if (strcmp(name, "List_of_Covariance_Records") == 0) tag = TAG_3_List_of_Covariance_Records;
    else if (strcmp(name, "List_of_SP3c_Records") == 0)       tag = TAG_3_List_of_SP3c_Records;
    else if (strcmp(name, "List_of_Rotation_Records") == 0)   tag = TAG_3_List_of_Rotation_Records;
    else if (strcmp(name, "List_of_PDF_Files") == 0)          tag = TAG_3_List_of_PDF_Files;
    else tag = TAG_3_ERROR;
    break;

  case 4:
    if (strcmp(name, "Time_Information") == 0)       tag = TAG_4_Time_Information;
    else if (strcmp(name, "Gravity_Gradients") == 0) tag = TAG_4_Gravity_Gradients;
    else if (strcmp(name, "Sigmas") == 0)            tag = TAG_4_Sigmas;
    else if (strcmp(name, "Flags") == 0)             tag = TAG_4_Flags;
    else if (strcmp(name, "Corrections") == 0)       tag = TAG_4_Corrections;
    else if (strcmp(name, "Quaternions") == 0)       tag = TAG_4_Quaternions;
    else if (strcmp(name, "Covariance_Record") == 0) tag = TAG_4_Covariance_Record;
    else if (strcmp(name, "SP3c_Record") == 0)       tag = TAG_4_SP3c_Record;
    else if (strcmp(name, "Rotation_Record") == 0)   tag = TAG_4_Rotation_Record;
    else if (strcmp(name, "PDF_File") == 0)          tag = TAG_4_PDF_File;
    else tag = TAG_4_ERROR;
    break;

  case 5:
    if (strcmp(name, "GPS_Time") == 0)         tag = TAG_5_GPS_Time;
    else if (strcmp(name, "XX") == 0)          tag = TAG_5_XX;
    else if (strcmp(name, "YY") == 0)          tag = TAG_5_YY;
    else if (strcmp(name, "ZZ") == 0)          tag = TAG_5_ZZ;
    else if (strcmp(name, "XY") == 0)          tag = TAG_5_XY;
    else if (strcmp(name, "XZ") == 0)          tag = TAG_5_XZ;
    else if (strcmp(name, "YZ") == 0)          tag = TAG_5_YZ;
    else if (strcmp(name, "Temporal") == 0)    tag = TAG_5_Temporal;
    else if (strcmp(name, "Calibration") == 0) tag = TAG_5_Calibration;
    else if (strcmp(name, "Q1") == 0)          tag = TAG_5_Q1;
    else if (strcmp(name, "Q2") == 0)          tag = TAG_5_Q2;
    else if (strcmp(name, "Q3") == 0)          tag = TAG_5_Q3;
    else if (strcmp(name, "Q4") == 0)          tag = TAG_5_Q4;
    else if (strcmp(name, "Time_Information") == 0)      tag = TAG_5_Time_Information;
    else if (strcmp(name, "List_of_Satellite_IDs") == 0) tag = TAG_5_List_of_Satellite_IDs;
    else if (strcmp(name, "Quaternions") == 0)           tag = TAG_5_Quaternions;
    else tag = TAG_5_ERROR;
    break;

  case 6:
    if (strcmp(name, "Tidal") == 0)          tag = TAG_6_Tidal;
    else if (strcmp(name, "Non-Tidal") == 0) tag = TAG_6_Non_Tidal;
    else if (strcmp(name, "XX") == 0)        tag = TAG_6_XX;
    else if (strcmp(name, "YY") == 0)        tag = TAG_6_YY;
    else if (strcmp(name, "ZZ") == 0)        tag = TAG_6_ZZ;
    else if (strcmp(name, "XY") == 0)        tag = TAG_6_XY;
    else if (strcmp(name, "XZ") == 0)        tag = TAG_6_XZ;
    else if (strcmp(name, "YZ") == 0)        tag = TAG_6_YZ;
    else if (strcmp(name, "GPS_Time") == 0)  tag = TAG_6_GPS_Time;
    else if (strcmp(name, "L15") == 0)       tag = TAG_6_L15;
    else if (strcmp(name, "Time_Since_Reference_Epoch") == 0) tag = TAG_6_Time_Since_Reference_Epoch;
    else if (strcmp(name, "Q1") == 0)        tag = TAG_6_Q1;
    else if (strcmp(name, "Q2") == 0)        tag = TAG_6_Q2;
    else if (strcmp(name, "Q3") == 0)        tag = TAG_6_Q3;
    else if (strcmp(name, "Q4") == 0)        tag = TAG_6_Q4;
    else tag = TAG_6_ERROR;
    break;

  case 7:
    if (strcmp(name, "Direct_Tides") == 0)     tag = TAG_7_Direct_Tides;
    else if (strcmp(name, "Solid_Earth") == 0) tag = TAG_7_Solid_Earth;
    else if (strcmp(name, "Ocean_Tides") == 0) tag = TAG_7_Ocean_Tides;
    else if (strcmp(name, "Pole_Tides") == 0)  tag = TAG_7_Pole_Tides;
    else if (strcmp(name, "XX") == 0)          tag = TAG_7_XX;
    else if (strcmp(name, "YY") == 0)          tag = TAG_7_YY;
    else if (strcmp(name, "ZZ") == 0)          tag = TAG_7_ZZ;
    else if (strcmp(name, "XY") == 0)          tag = TAG_7_XY;
    else if (strcmp(name, "XZ") == 0)          tag = TAG_7_XZ;
    else if (strcmp(name, "YZ") == 0)          tag = TAG_7_YZ;
    else if (strcmp(name, "Start") == 0)       tag = TAG_7_Start;
    else if (strcmp(name, "Position") == 0)    tag = TAG_7_Position;
    else if (strcmp(name, "Velocity") == 0)    tag = TAG_7_Velocity;
    else if (strcmp(name, "Clock") == 0)       tag = TAG_7_Clock;
    else if (strcmp(name, "Clock_Change_Rate") == 0)   tag = TAG_7_Clock_Change_Rate;
    else if (strcmp(name, "Standard_Deviations") == 0) tag = TAG_7_Standard_Deviations;
    else tag = TAG_7_ERROR;
    break;

  case 8:
    if (strcmp(name, "XX") == 0)      tag = TAG_8_XX;
    else if (strcmp(name, "YY") == 0) tag = TAG_8_YY;
    else if (strcmp(name, "ZZ") == 0) tag = TAG_8_ZZ;
    else if (strcmp(name, "XY") == 0) tag = TAG_8_XY;
    else if (strcmp(name, "XZ") == 0) tag = TAG_8_XZ;
    else if (strcmp(name, "YZ") == 0) tag = TAG_8_YZ;
    else if (strcmp(name, "Gregorian") == 0)           tag = TAG_8_Gregorian;
    else if (strcmp(name, "X") == 0)                   tag = TAG_8_X;
    else if (strcmp(name, "Y") == 0)                   tag = TAG_8_Y;
    else if (strcmp(name, "Z") == 0)                   tag = TAG_8_Z;
    else if (strcmp(name, "Position") == 0)            tag = TAG_8_Position;
    else if (strcmp(name, "Velocity") == 0)            tag = TAG_8_Velocity;
    else if (strcmp(name, "Clock") == 0)               tag = TAG_8_Clock;
    else if (strcmp(name, "Clock_Change_Rate") == 0)   tag = TAG_8_Clock_Change_Rate;
    else tag = TAG_8_ERROR;
    break;

  case 9:
    if (strcmp(name, "Year") == 0)              tag = TAG_9_Year;
    else if (strcmp(name, "Month") == 0)        tag = TAG_9_Month;
    else if (strcmp(name, "Day_of_Month") == 0) tag = TAG_9_Day_of_Month;
    else if (strcmp(name, "Hour") == 0)         tag = TAG_9_Hour;
    else if (strcmp(name, "Minute") == 0)       tag = TAG_9_Minute;
    else if (strcmp(name, "Second") == 0)       tag = TAG_9_Second;
    else tag = TAG_9_NONE;
    break;
  }

  //  printf(" TAG: level %d --> tag %d \n", level, tag); // DEBUG!!!!
 
  return tag;
}


int HDR_GetNodeTagfromFile(const xmlChar *name) {
  unsigned int tag = HDR_TAG_NONE;

  if (strcmp(name, "Earth_Explorer_Header") == 0) tag = HDR_TAG_Earth_Explorer_Header;
  else if (strcmp(name, "Variable_Header") == 0) tag = HDR_TAG_Variable_Header;
  else if (strcmp(name, "SPH") == 0) tag = HDR_TAG_SPH;
  else if (strcmp(name, "SST_PSO_2") == 0) tag = HDR_TAG_SST_PSO_2;
  else if (strcmp(name, "SST_PRM_2") == 0) tag = HDR_TAG_SST_PRM_2;
  else if (strcmp(name, "Epoch_Information") == 0) tag = HDR_TAG_Epoch_Information;
  else if (strcmp(name, "Reference") == 0) tag = HDR_TAG_Reference;

  return tag;
}
