#ifndef TAGS_H_SEEN
#define TAGS_H_SEEN

enum TAG_level_0 { 
  TAG_0_ERROR = -1,
  TAG_0_NONE = 0,
  TAG_0_Data_Block,
};
enum TAG_level_1 { 
  TAG_1_ERROR = -1,
  TAG_1_NONE = 0,
  TAG_1_EGG_NOM_2,
  TAG_1_SST_PSO_2,
};              
enum TAG_level_2 {
  TAG_2_ERROR = -1,
  TAG_2_NONE = 0,
  TAG_2_List_of_GG_time_Records,
  TAG_2_SST_PCV_2,
  TAG_2_SST_PKI_2,
  TAG_2_SST_PRD_2,
  TAG_2_SST_PRM_2,
  TAG_2_SST_PRP_2,
};
enum TAG_level_3 {
  TAG_3_ERROR = -1,
  TAG_3_NONE = 0,
  TAG_3_GG_time_Record,
  TAG_3_List_of_Covariance_Records,
  TAG_3_List_of_SP3c_Records,
  TAG_3_List_of_Rotation_Records,
  TAG_3_List_of_PDF_Files,
};
enum TAG_level_4 {
  TAG_4_ERROR = -1,
  TAG_4_NONE = 0,
  TAG_4_Time_Information,
  TAG_4_Gravity_Gradients,
  TAG_4_Sigmas,
  TAG_4_Flags,
  TAG_4_Corrections,
  TAG_4_Quaternions,
  TAG_4_Covariance_Record,
  TAG_4_SP3c_Record,
  TAG_4_Rotation_Record,
  TAG_4_PDF_File,
};
enum TAG_level_5 {
  TAG_5_ERROR = -1,
  TAG_5_NONE = 0,
  TAG_5_GPS_Time,
  TAG_5_XX,
  TAG_5_YY,
  TAG_5_ZZ,
  TAG_5_XY,
  TAG_5_XZ,
  TAG_5_YZ,
  TAG_5_Temporal,
  TAG_5_Calibration,
  TAG_5_Q1,
  TAG_5_Q2,
  TAG_5_Q3,
  TAG_5_Q4,
  TAG_5_Time_Information,
  TAG_5_List_of_Satellite_IDs,
  TAG_5_Quaternions,
};
enum TAG_level_6 {
  TAG_6_ERROR = -1,
  TAG_6_NONE = 0,
  TAG_6_Tidal,
  TAG_6_Non_Tidal,
  TAG_6_XX,
  TAG_6_YY,
  TAG_6_ZZ,
  TAG_6_XY,
  TAG_6_XZ,
  TAG_6_YZ,
  TAG_6_GPS_Time,
  TAG_6_L15,
  TAG_6_Time_Since_Reference_Epoch,
  TAG_6_Q1,
  TAG_6_Q2,
  TAG_6_Q3,
  TAG_6_Q4,
};
enum TAG_level_7 {
  TAG_7_ERROR = -1,
  TAG_7_NONE = 0,
  TAG_7_Direct_Tides,
  TAG_7_Solid_Earth,
  TAG_7_Ocean_Tides,
  TAG_7_Pole_Tides,
  TAG_7_XX,
  TAG_7_YY,
  TAG_7_ZZ,
  TAG_7_XY,
  TAG_7_XZ,
  TAG_7_YZ,
  TAG_7_Start,
  TAG_7_Position,
  TAG_7_Velocity,
  TAG_7_Clock,
  TAG_7_Clock_Change_Rate,
  TAG_7_Standard_Deviations,
  TAG_7_Flags,
};
enum TAG_level_8 {
  TAG_8_ERROR = -1,
  TAG_8_NONE = 0,
  TAG_8_XX,
  TAG_8_YY,
  TAG_8_ZZ,
  TAG_8_XY,
  TAG_8_XZ,
  TAG_8_YZ,
  TAG_8_Gregorian,
  TAG_8_X,
  TAG_8_Y,
  TAG_8_Z,
  TAG_8_Position,
  TAG_8_Velocity,
  TAG_8_Clock,
  TAG_8_Clock_Change_Rate,
  TAG_8_Standard_Deviations,
};
enum TAG_level_9 {
  TAG_9_ERROR = -1,
  TAG_9_NONE = 0,
  TAG_9_Year,
  TAG_9_Month,
  TAG_9_Day_of_Month,
  TAG_9_Hour,
  TAG_9_Minute,
  TAG_9_Second,
};
enum TAG_extra {
  TAG_extra_ERROR = -1,
  TAG_extra_NONE  = 0,
  TAG_extra_ROW_COLUMN,
  TAG_extra_VALUE,
};



#define HDR_TAG_NONE                  0b00000000
#define HDR_TAG_Earth_Explorer_Header 0b00000001
#define HDR_TAG_Variable_Header       0b00000010
#define HDR_TAG_SPH                   0b00000100
#define HDR_TAG_SST_PSO_2             0b00001000
#define HDR_TAG_SST_PRM_2             0b00010000
#define HDR_TAG_Epoch_Information     0b00100000
#define HDR_TAG_Reference             0b01000000


struct t_tag_flags {
  int level_0, level_1, level_2, level_3, level_4, 
    level_5, level_6, level_7, level_8, level_9;
} TAG_flags;

int HDR_TAG_flags;

int GetNodeTagfromName(const xmlChar *name, int level);
int HDR_GetNodeTagfromFile(const xmlChar *name);

#endif // !TAGS_H_SEEN
